package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.domain.Specifications;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.entities.DetailDraftPeraturan;
import com.jasamedika.medifirst2000.entities.DraftPeraturan;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.DetailDraftPeraturanService;
import com.jasamedika.medifirst2000.service.DraftPeraturanService;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.DetailDraftPeraturanVO;
import com.jasamedika.medifirst2000.vo.DraftPeraturanVO;

import net.kaczmarzyk.spring.data.jpa.domain.DateBetween;
import net.kaczmarzyk.spring.data.jpa.domain.Equal;
import net.kaczmarzyk.spring.data.jpa.web.annotation.Spec;

@RestController
@RequestMapping("/draft-peraturan")
public class DraftPeraturanController extends LocaleController<DraftPeraturanVO>
implements IBaseRestController<DraftPeraturanVO>{

	@Autowired
	private DraftPeraturanService peraturanService;
	
	@Autowired
	private DetailDraftPeraturanService detailService;
	
	private static final Logger LOGGER = LoggerFactory
			.getLogger(PegawaiController.class);

	@Override
	public ResponseEntity<Collection<DraftPeraturanVO>> getAllVOWithQueryString(HttpServletRequest request,
			Integer page, Integer limit, String sort, String dir) {
		return null;
	}

	@Override
	public ResponseEntity<DraftPeraturanVO> getVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<String> addVO(DraftPeraturanVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> editVO(DraftPeraturanVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<List<DraftPeraturanVO>> getAllVO() {
		return null;
	}
	
	@RequestMapping(value="/find-all/",method= RequestMethod.GET)
	public ResponseEntity<List<Object>> findAll(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "20") Integer take,
			@RequestParam(value = "sort", required = false, defaultValue = "id") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@Spec(path = "tglPeraturan", params = {"dateStart", "dateEnd"}, config = "yyyy-MM-dd", spec = DateBetween.class) Specification<DraftPeraturan> tglPeraturan,
			@Spec(path = "noPeraturan", params = "noPeraturan" , spec = Equal.class) Specification<DraftPeraturan> noPeraturan) {
			Map<String,Object> result = new HashMap<String, Object>();
			
			Specification<DraftPeraturan> spec = Specifications.where(tglPeraturan).and(noPeraturan);
			result = peraturanService.findAll(page, take, sort, dir, spec);
			return constructListPageResult(result);
	}
	
	@RequestMapping(value="/save/",method= RequestMethod.POST)
	public ResponseEntity<Map<String,Object>> saveKajian(@Valid @RequestBody DraftPeraturanVO vo,HttpServletRequest request){
		try{
			Map<String, Object> result = peraturanService.saveDraft(vo);
			if(null!= result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS,request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add draft peraturan", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add draft peraturan", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	
	@RequestMapping(value="/generate-no-peraturan/{bulan}/{tahun}",method= RequestMethod.GET)
	public ResponseEntity<Map<String,Object>> getGenerateNoUsulan(
			@PathVariable("bulan") Integer bulan,
			@PathVariable("tahun") Integer tahun,
			HttpServletRequest request)
	{
		try{
			Map<String,Object> result = peraturanService.generateNoPeraturan(bulan, tahun);
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
		}catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when generate no usulan", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when generate no usulan", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}
	}
	
	@RequestMapping(value="/delete/",method= RequestMethod.POST)
	public ResponseEntity<Map<String,Object>> deleteKajian(@Valid @RequestBody List<DraftPeraturanVO> vos,HttpServletRequest request){
		try{
			Map<String, Object> result = peraturanService.deleteDraft(vos);
			if(null!= result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS,request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when delete draft", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when delete draft", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	
	@RequestMapping(value="/update-draft/",method= RequestMethod.POST)
	public ResponseEntity<Map<String,Object>> updateKajian(@Valid @RequestBody List<DetailDraftPeraturanVO> vos,HttpServletRequest request){
		try{
			Map<String, Object> result = detailService.updateDraft(vos);
			if(null!= result)
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS,request));
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED, mapHeaderMessage);
			
		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when update kajian", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR,
					mapHeaderMessage);
			
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when update kajian", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE,
					jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT,
					mapHeaderMessage);
		}
	}
	
	@RequestMapping(value="/find-all-by-jabatan/",method= RequestMethod.GET)
	public ResponseEntity<List<Object>> findAllByJabatan(
			@RequestParam(value = "page", required = false, defaultValue = "0") Integer page,
			@RequestParam(value = "take", required = false, defaultValue = "20") Integer take,
			@RequestParam(value = "sort", required = false, defaultValue = "id") String sort,
			@RequestParam(value = "dir", required = false, defaultValue = "asc") String dir,
			@Spec(path = "draftPeraturan.tglPeraturan", params = {"dateStart", "dateEnd"}, config = "yyyy-MM-dd", spec = DateBetween.class) Specification<DetailDraftPeraturan> tglPeraturan,
			@Spec(path = "draftPeraturan.noPeraturan", params = "noUsulan" , spec = Equal.class) Specification<DetailDraftPeraturan> noPeraturan,
			@Spec(path = "tujuanDraft.id",params="jabatanId",spec=Equal.class)Specification<DetailDraftPeraturan> tujuanId) {
			Map<String,Object> result = new HashMap<String, Object>();
			
			Specification<DetailDraftPeraturan> spec = Specifications.where(tglPeraturan).and(tujuanId).and(noPeraturan);
			result = detailService.findAll(page, take, sort, dir, spec);
			return constructListPageResult(result);
	}
}
